Package com.sas.metadata.remote

# Interface Dimension

All Superinterfaces:
  `Classifier`, `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

All Known Subinterfaces:
  `SharedDimension`

public interface Dimension extends Classifier
A group of closely related hierarchies. Hierarchies within a dimension typically represent different groupings of information that pertains to a single concept. For example, a Time dimension might consist of two hierarchies: (1) Year, Month, Date, and (2) Year, Week, Day. See also hierarchy.

Attributes of Dimension are:

- `DimensionType`
- `Cardinality`
- `UniqueName`
- `SortOrder`

Associations of Dimension are:

- `AssociatedOLAPSchema`
- `Cubes`
- `Hierarchies`
- `Levels`
- `Measures`

## Usage

To create an instance of this Dimension, use the `factory` create methods.
Example: create a Dimension with name "Dimension_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     Dimension myObject = (Dimension) factory.createComplexMetadataObject(objectStore, "Dimension_Object", MetadataObjects.DIMENSION, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_ASSOCIATEDOLAPSCHEMA_NAME`
  Constant used for the name of the AssociatedOLAPSchema association.
  `static final String`
  `ASSOCIATION_CUBES_NAME`
  Constant used for the name of the Cubes association.
  `static final String`
  `ASSOCIATION_HIERARCHIES_NAME`
  Constant used for the name of the Hierarchies association.
  `static final String`
  `ASSOCIATION_LEVELS_NAME`
  Constant used for the name of the Levels association.
  `static final String`
  `ASSOCIATION_MEASURES_NAME`
  Constant used for the name of the Measures association.
  `static final String`
  `ATTRIBUTE_CARDINALITY_NAME`
  Constant used for the name of the Cardinality attribute.
  `static final String`
  `ATTRIBUTE_DIMENSIONTYPE_NAME`
  Constant used for the name of the DimensionType attribute.
  `static final String`
  `ATTRIBUTE_SORTORDER_NAME`
  Constant used for the name of the SortOrder attribute.
  `static final String`
  `ATTRIBUTE_UNIQUENAME_NAME`
  Constant used for the name of the UniqueName attribute.

  ### Fields inherited from interface com.sas.metadata.remote.Classifier

  `ASSOCIATION_SOURCECLASSIFIERMAPS_NAME, ASSOCIATION_TARGETCLASSIFIERMAPS_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `OLAPSchema`
  `getAssociatedOLAPSchema()`
  Gets the `OLAPSchema` for `AssociatedOLAPSchema`
  `AssociationList`
  `getAssociatedOLAPSchemas()`
  Gets the AssociationList of `AssociatedOLAPSchemas`
  `AssociationList`
  `getAssociatedOLAPSchemas(boolean fGoToServer)`
  Gets the Associationlist of `AssociatedOLAPSchemas`
  `double`
  `getCardinality()`
  Gets the `double` value of `Cardinality`
  `int`
  `getCardinalityState()`
  Gets the Metadata State of `Cardinality`
  `AssociationList`
  `getCubes()`
  Gets the Association list of `Cubes`
  `AssociationList`
  `getCubes(boolean fGoToServer)`
  Gets the Associationlist of `Cubes`
  `String`
  `getDimensionType()`
  Gets the `String` value of `DimensionType`
  `int`
  `getDimensionTypeMaxLength()`
  Gets the maximum length of `DimensionType`
  `int`
  `getDimensionTypeState()`
  Gets the Metadata State of `DimensionType`
  `AssociationList`
  `getHierarchies()`
  Gets the Association list of `Hierarchies`
  `AssociationList`
  `getHierarchies(boolean fGoToServer)`
  Gets the Associationlist of `Hierarchies`
  `AssociationList`
  `getLevels()`
  Gets the Association list of `Levels`
  `AssociationList`
  `getLevels(boolean fGoToServer)`
  Gets the Associationlist of `Levels`
  `AssociationList`
  `getMeasures()`
  Gets the Association list of `Measures`
  `AssociationList`
  `getMeasures(boolean fGoToServer)`
  Gets the Associationlist of `Measures`
  `String`
  `getSortOrder()`
  Gets the `String` value of `SortOrder`
  `int`
  `getSortOrderMaxLength()`
  Gets the maximum length of `SortOrder`
  `int`
  `getSortOrderState()`
  Gets the Metadata State of `SortOrder`
  `String`
  `getUniqueName()`
  Gets the `String` value of `UniqueName`
  `int`
  `getUniqueNameMaxLength()`
  Gets the maximum length of `UniqueName`
  `int`
  `getUniqueNameState()`
  Gets the Metadata State of `UniqueName`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `AssociatedOLAPSchema`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setAssociatedOLAPSchema(OLAPSchema inObject)`
  Sets the `AssociatedOLAPSchemas` list 0th element to be `inObject`.
  `void`
  `setAssociatedOLAPSchemas(AssociationList list)`
  Sets the `AssociatedOLAPSchemas` list to be `list`.
  `void`
  `setAssociatedOLAPSchemas(AssociationList list, int state)`
  Sets the `AssociatedOLAPSchemas` list to be `list`.
  `void`
  `setCardinality(double inCardinality)`
  Sets the `Cardinality` value and sets the state to MetadataState.LOCAL.
  `void`
  `setCardinality(double inCardinality, int state)`
  Sets the `Cardinality` Metadata State.
  `void`
  `setCardinality(String inCardinality)`
  Sets the `Cardinality` value and sets the state to MetadataState.LOCAL
  `void`
  `setCardinality(String inCardinality, int state)`
  Sets the `Cardinality` value and Metadata State.
  `void`
  `setCardinalityState(int state)`
  Sets the Metadata State of `Cardinality`.
  `void`
  `setCubes(AssociationList list)`
  Sets the `Cubes` list to be `list`.
  `void`
  `setCubes(AssociationList inObjects, int state)`
  Sets the entire Cubes list to match the passed in AssociationList, sets the state of the Cubes
  `void`
  `setDimensionType(String inDimensionType)`
  Sets the `DimensionType` value and sets the state to MetadataState.LOCAL.
  `void`
  `setDimensionType(String inDimensionType, int state)`
  Sets the `DimensionType` Metadata State.
  `void`
  `setDimensionTypeState(int state)`
  Sets the Metadata State of `DimensionType`.
  `void`
  `setHierarchies(AssociationList list)`
  Sets the `Hierarchies` list to be `list`.
  `void`
  `setHierarchies(AssociationList inObjects, int state)`
  Sets the entire Hierarchies list to match the passed in AssociationList, sets the state of the Hierarchies
  `void`
  `setLevels(AssociationList list)`
  Sets the `Levels` list to be `list`.
  `void`
  `setLevels(AssociationList inObjects, int state)`
  Sets the entire Levels list to match the passed in AssociationList, sets the state of the Levels
  `void`
  `setMeasures(AssociationList list)`
  Sets the `Measures` list to be `list`.
  `void`
  `setMeasures(AssociationList inObjects, int state)`
  Sets the entire Measures list to match the passed in AssociationList, sets the state of the Measures
  `void`
  `setSortOrder(String inSortOrder)`
  Sets the `SortOrder` value and sets the state to MetadataState.LOCAL.
  `void`
  `setSortOrder(String inSortOrder, int state)`
  Sets the `SortOrder` Metadata State.
  `void`
  `setSortOrderState(int state)`
  Sets the Metadata State of `SortOrder`.
  `void`
  `setUniqueName(String inUniqueName)`
  Sets the `UniqueName` value and sets the state to MetadataState.LOCAL.
  `void`
  `setUniqueName(String inUniqueName, int state)`
  Sets the `UniqueName` Metadata State.
  `void`
  `setUniqueNameState(int state)`
  Sets the Metadata State of `UniqueName`.

  ### Methods inherited from interface com.sas.metadata.remote.Classifier

  `getSourceClassifierMaps, getSourceClassifierMaps, getTargetClassifierMaps, getTargetClassifierMaps, setSourceClassifierMaps, setSourceClassifierMaps, setTargetClassifierMaps, setTargetClassifierMaps`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_DIMENSIONTYPE_NAME

    static final String ATTRIBUTE_DIMENSIONTYPE_NAME
    Constant used for the name of the DimensionType attribute.

    DimensionType: The type of this dimension: STANDARD, MEASURES or TIME.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_CARDINALITY_NAME

    static final String ATTRIBUTE_CARDINALITY_NAME
    Constant used for the name of the Cardinality attribute.

    Cardinality: The number of unique values for the dimension.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_UNIQUENAME_NAME

    static final String ATTRIBUTE_UNIQUENAME_NAME
    Constant used for the name of the UniqueName attribute.

    UniqueName: The unique name for this dimension.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_SORTORDER_NAME

    static final String ATTRIBUTE_SORTORDER_NAME
    Constant used for the name of the SortOrder attribute.

    SortOrder: This is an indication of the sort order of this column in this table. It can be ASCENDING, DESCENDING, ASCFORMATTED, DESFORMATTED, DSORDER.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_ASSOCIATEDOLAPSCHEMA_NAME

    static final String ASSOCIATION_ASSOCIATEDOLAPSCHEMA_NAME
    Constant used for the name of the AssociatedOLAPSchema association.

    AssociatedOLAPSchema: The OLAP schema that contains this dimension.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_CUBES_NAME

    static final String ASSOCIATION_CUBES_NAME
    Constant used for the name of the Cubes association.

    Cubes: The list of cubes that include this dimension.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_HIERARCHIES_NAME

    static final String ASSOCIATION_HIERARCHIES_NAME
    Constant used for the name of the Hierarchies association.

    Hierarchies: The list of hierarchies for this dimension.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_LEVELS_NAME

    static final String ASSOCIATION_LEVELS_NAME
    Constant used for the name of the Levels association.

    Levels: The list of levels for this dimension.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_MEASURES_NAME

    static final String ASSOCIATION_MEASURES_NAME
    Constant used for the name of the Measures association.

    Measures: *Unknown*

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `Classifier`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `AssociatedOLAPSchema`
    Specified by:
      `initializePredObjects` in interface `Classifier`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDimensionType

    String getDimensionType() throws RemoteException
    Gets the `String` value of `DimensionType`
    Returns:
      The `DimensionType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDimensionTypeState

    int getDimensionTypeState() throws RemoteException
    Gets the Metadata State of `DimensionType`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDimensionTypeMaxLength

    int getDimensionTypeMaxLength() throws RemoteException
    Gets the maximum length of `DimensionType`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCardinality

    double getCardinality() throws RemoteException
    Gets the `double` value of `Cardinality`
    Returns:
      The `Cardinality`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCardinalityState

    int getCardinalityState() throws RemoteException
    Gets the Metadata State of `Cardinality`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getUniqueName

    String getUniqueName() throws RemoteException
    Gets the `String` value of `UniqueName`
    Returns:
      The `UniqueName`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getUniqueNameState

    int getUniqueNameState() throws RemoteException
    Gets the Metadata State of `UniqueName`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getUniqueNameMaxLength

    int getUniqueNameMaxLength() throws RemoteException
    Gets the maximum length of `UniqueName`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSortOrder

    String getSortOrder() throws RemoteException
    Gets the `String` value of `SortOrder`
    Returns:
      The `SortOrder`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSortOrderState

    int getSortOrderState() throws RemoteException
    Gets the Metadata State of `SortOrder`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSortOrderMaxLength

    int getSortOrderMaxLength() throws RemoteException
    Gets the maximum length of `SortOrder`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAssociatedOLAPSchemas

    AssociationList getAssociatedOLAPSchemas() throws RemoteException, MdException
    Gets the AssociationList of `AssociatedOLAPSchemas`
    Returns:
      Returns the AssociationList of `AssociatedOLAPSchemas` which can be of type:
      OLAPSchema
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getAssociatedOLAPSchema

    OLAPSchema getAssociatedOLAPSchema() throws RemoteException, MdException
    Gets the `OLAPSchema` for `AssociatedOLAPSchema`
    Returns:
      The `OLAPSchema` ( `null` if not set) of `AssociatedOLAPSchema`which can be of type:
      OLAPSchema
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getCubes

    AssociationList getCubes() throws RemoteException, MdException
    Gets the Association list of `Cubes`
    Returns:
      The AssociationList of `Cubes` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getHierarchies

    AssociationList getHierarchies() throws RemoteException, MdException
    Gets the Association list of `Hierarchies`
    Returns:
      The AssociationList of `Hierarchies` which can be of type:
      Hierarchy
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getLevels

    AssociationList getLevels() throws RemoteException, MdException
    Gets the Association list of `Levels`
    Returns:
      The AssociationList of `Levels` which can be of type:
      Level
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getMeasures

    AssociationList getMeasures() throws RemoteException, MdException
    Gets the Association list of `Measures`
    Returns:
      The AssociationList of `Measures` which can be of type:
      Measure
      CalculatedMeasure
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedOLAPSchemas

    AssociationList getAssociatedOLAPSchemas(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `AssociatedOLAPSchemas`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `AssociatedOLAPSchemas` which can be of type:
      OLAPSchema
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getCubes

    AssociationList getCubes(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Cubes`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Cubes` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getHierarchies

    AssociationList getHierarchies(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Hierarchies`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Hierarchies` which can be of type:
      Hierarchy
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getLevels

    AssociationList getLevels(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Levels`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Levels` which can be of type:
      Level
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getMeasures

    AssociationList getMeasures(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Measures`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Measures` which can be of type:
      Measure
      CalculatedMeasure
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setDimensionType

    void setDimensionType(String inDimensionType) throws RemoteException
    Sets the `DimensionType` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inDimensionType` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDimensionType

    void setDimensionType(String inDimensionType, int state) throws RemoteException
    Sets the `DimensionType` Metadata State.
    Parameters:
      `inDimensionType` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDimensionTypeState

    void setDimensionTypeState(int state) throws RemoteException
    Sets the Metadata State of `DimensionType`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCardinality

    void setCardinality(double inCardinality) throws RemoteException
    Sets the `Cardinality` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inCardinality` - double
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCardinality

    void setCardinality(double inCardinality, int state) throws RemoteException
    Sets the `Cardinality` Metadata State.
    Parameters:
      `inCardinality` - double
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCardinality

    void setCardinality(String inCardinality) throws RemoteException
    Sets the `Cardinality` value and sets the state to MetadataState.LOCAL
    Parameters:
      `inCardinality` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCardinality

    void setCardinality(String inCardinality, int state) throws RemoteException
    Sets the `Cardinality` value and Metadata State.
    Parameters:
      `inCardinality` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCardinalityState

    void setCardinalityState(int state) throws RemoteException
    Sets the Metadata State of `Cardinality`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setUniqueName

    void setUniqueName(String inUniqueName) throws RemoteException
    Sets the `UniqueName` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inUniqueName` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setUniqueName

    void setUniqueName(String inUniqueName, int state) throws RemoteException
    Sets the `UniqueName` Metadata State.
    Parameters:
      `inUniqueName` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setUniqueNameState

    void setUniqueNameState(int state) throws RemoteException
    Sets the Metadata State of `UniqueName`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSortOrder

    void setSortOrder(String inSortOrder) throws RemoteException
    Sets the `SortOrder` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inSortOrder` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSortOrder

    void setSortOrder(String inSortOrder, int state) throws RemoteException
    Sets the `SortOrder` Metadata State.
    Parameters:
      `inSortOrder` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSortOrderState

    void setSortOrderState(int state) throws RemoteException
    Sets the Metadata State of `SortOrder`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedOLAPSchemas

    void setAssociatedOLAPSchemas(AssociationList list) throws RemoteException
    Sets the `AssociatedOLAPSchemas` list to be `list`. Object of which can be of type:
    OLAPSchema
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedOLAPSchemas

    void setAssociatedOLAPSchemas(AssociationList list, int state) throws RemoteException
    Sets the `AssociatedOLAPSchemas` list to be `list`. Object of which can be of type:
    OLAPSchema
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedOLAPSchema

    void setAssociatedOLAPSchema(OLAPSchema inObject) throws RemoteException
    Sets the `AssociatedOLAPSchemas` list 0th element to be `inObject`.
    Parameters:
      `inObject` - OLAPSchema
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCubes

    void setCubes(AssociationList list) throws RemoteException
    Sets the `Cubes` list to be `list`. Objects of which can be of type:
    Cube
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCubes

    void setCubes(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Cubes list to match the passed in AssociationList, sets the state of the Cubes
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setHierarchies

    void setHierarchies(AssociationList list) throws RemoteException
    Sets the `Hierarchies` list to be `list`. Objects of which can be of type:
    Hierarchy
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setHierarchies

    void setHierarchies(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Hierarchies list to match the passed in AssociationList, sets the state of the Hierarchies
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLevels

    void setLevels(AssociationList list) throws RemoteException
    Sets the `Levels` list to be `list`. Objects of which can be of type:
    Level
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLevels

    void setLevels(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Levels list to match the passed in AssociationList, sets the state of the Levels
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMeasures

    void setMeasures(AssociationList list) throws RemoteException
    Sets the `Measures` list to be `list`. Objects of which can be of type:
    Measure
    CalculatedMeasure
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMeasures

    void setMeasures(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Measures list to match the passed in AssociationList, sets the state of the Measures
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.